# UI Fixes Summary

## Issues Fixed

### 1. Updated UI Text
- Removed "ChaCha20" from window title and protocol info
- Now shows: "Noise XK + Codec2 + 4FSK"

### 2. Waveform Display Fixed
- Improved `set_data()` method to properly handle PCM audio data
- Extracts 16-bit signed samples and normalizes amplitude
- Maintains rolling buffer of 50 samples for smooth visualization
- Both sent and received waveforms now update correctly

### 3. Layout Improvements
- Reduced phone display frame size: 250x350 → 220x300
- Fixed waveform widget size: 220x60
- Reduced spacing between phones: 50 → 30
- Shortened waveform labels: "Phone X Received Audio" → "Phone X Received"
- Set proper min/max heights for waveform widgets

### 4. Protocol Message Handling
- Fixed issue where large voice frames were misinterpreted as handshake messages
- Added check to only process 0x20 messages as handshake before handshake completes
- Prevents "pop from empty list" errors after handshake

## Visual Improvements
- More compact layout fits better on screen
- Waveforms show actual audio activity
- Clear visual feedback for voice transmission
- No overlapping UI elements

## Test Results
- ✓ Waveforms updating correctly
- ✓ Both sent and received audio displayed
- ✓ No layout issues
- ✓ Protocol continues working properly

The UI is now properly displaying the integrated protocol with working waveform visualization.